#include "pktfec.h"

#include <stdlib.h>
#include <stdio.h>

#define MAXPKTLEN 2048

int main(int argc, char **argv) {
  pktfec_decoder_t decoder;
  float *input;
  size_t inputlen;
  uint8_t *output;
  input = malloc((8*PKTFEC_BLOCKLEN) * sizeof(float));
  if (!input) return 1;
  inputlen = fread(input, sizeof(float), 8*PKTFEC_BLOCKLEN, stdin);
  if (ferror(stdin)) return 1;
  if (!pktfec_decode_start(&decoder, input, inputlen)) return 1;
  if (decoder.outputlen > MAXPKTLEN) return 1;
  free(input);
  input = malloc((8*decoder.extralen) * sizeof(float));
  if (decoder.extralen) {
    inputlen = fread(input, sizeof(float), 8*decoder.extralen, stdin);
  }
  if (ferror(stdin)) return 1;
  output = malloc(decoder.outputlen * sizeof(uint8_t));
  if (!output) return 1;
  if (!pktfec_decode_finish(&decoder, output, input, inputlen)) return 1;
  fwrite(output, 1, decoder.outputlen, stdout);
  if (ferror(stdout)) return 1;
  return 0;
}
